using System.Collections;
using UnityEngine;

public class GameManager : MonoBehaviour
{
    public StateMachine stateMachine;

    public CharaBase char1;
    public CharaBase char2;

    CharaBase player1;
    CharaBase player2;

    Coroutine GameLoop;

    IEnumerator Start()
    {
        player1 = Instantiate(char1, new Vector3(-1, 0, 0), Quaternion.identity);

        Weapon weapon = new Weapon
        {
            Name = "斧",
            Atk = 2
        };

        player1.equipment.AddWeapon(weapon);

        player2 = Instantiate(char2, new Vector3(1, 0, 0), Quaternion.identity);

        weapon = new Weapon
        {
            Name = "刀",
            Atk = 3
        };

        player2.equipment.AddWeapon(weapon);

        stateMachine.Player1Handler.AddListener(() => player1.Attack(player2));
        stateMachine.Player2Handler.AddListener(() => player2.Attack(player1));

        StartGameLoop();

        yield return StartCoroutine(GameEndCheck());

        Debug.Log("GameEnd");
    }

    void StartGameLoop()
    {
        GameLoop = StartCoroutine(stateMachine.Loop());
    }

    void StopGameLoop()
    {
        StopCoroutine(GameLoop);
    }

    IEnumerator GameEndCheck()
    {
        while (true)
        {
            yield return new WaitWhile(() => !Input.GetKeyDown(KeyCode.E));

            StopGameLoop();

            yield break;
        }
    }
}